﻿using parkMonitor.DB;
using parkMonitor.entity;
using parkMonitor.model;
using parkMonitor.server;
using parkMonitor.server.CoreThread;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MySql.Data.MySqlClient;

namespace parkMonitor.bll
{
    /// <summary>主业务逻辑</summary>
    public class MainBll
    {
        public void init()
        {
            //中控状态监控服务
            PcStatusServer.ins.start();
            //监控线程
            //PLCMonitorServer.ins.Start();
            var monitorThread = EquipmentSimpleFactory.ins.CreateEquipment(EquipmentName.Monitor);
            if (monitorThread != null)
            {
                monitorThread.Start();
            }
            //核心线程
            var coreThread = EquipmentSimpleFactory.ins.CreateEquipment(EquipmentName.Core);
            if (coreThread != null)
            {
                coreThread.Start();
                Task.Factory.StartNew(() =>
                {
                    (coreThread as ICoreThreadDoWorking).BeginWorking();
                });
            }

            //数据库测试
            //IDBOperator oper = new Operator();
            ////string sql = "insert into zxpark.vehicle value('京PH33X4','3','','','1','1','','1','','11')";
            //string sql = "select * from parkingspace where parkingSpaceState = 0 ";
            //MySqlConnection con = oper.getConn();
            //try
            //{
            //    con.Open();
            //}
            //catch (Exception ex)
            //{
            //    Console.WriteLine(ex.Message);
            //}
            //MySqlCommand cmd = oper.getComm(sql, con);
            //try
            //{
            //    MySqlDataReader reader = oper.getResultSet(cmd);

            //}
            //catch (Exception) { Console.WriteLine("读不到数据"); }
            ////oper.getInsert(cmd);
            //con.Close();

            //DBOperation o = new DBOperation();
            //List<Parking_Space> l = o.GetParkingSpace();
            //if (l.Count != 0)
            //{
            //    Console.WriteLine("输出："+l[0].parkingSpaceID);
            //}

            //IEquipments nml = EquipmentSimpleFactory.ins.FindEquipment(EquipmentName.NumMachine);
            //int count = 10;
            //Task.Factory.StartNew(() =>
            //{
            //    while (count-- > 0)
            //    {
            //        while (true)
            //        {
            //            NumberMachineNode nmn = ((NumberMachineMessage)nml.GetMessage()).aModel;
            //            if (nmn != null && nmn.ip != "")
            //            {
            //                o.InsertToParkingRecords(14, nmn.LicenseNum, 2, 1, 3, nmn.TimeRecord);
            //                nmn.ip = "";
            //                break;
            //            }
            //        }
            //    }
            //});

            //队列线程测试
            //int qCount = 4;
            //IEquipments qt = EquipmentSimpleFactory.ins.FindEquipment(EquipmentName.Queue);
            //Task.Factory.StartNew(() =>
            //{
            //    Command cmd = null;
            //    while (qCount-- > 0)
            //    {
            //        cmd = (Command)qt.GetMessage();
            //        while (true)
            //        {
            //            if (cmd != null)
            //            {
            //                Console.WriteLine("输出号牌为：" + cmd.LicenseNum);
            //                Console.WriteLine("输出号牌为：" + cmd.LicenseNum);
            //                break;
            //            }
            //        }
            //        Console.WriteLine("第" + qCount + "轮循环");
            //    }
            //});

            //主窗口关闭事件
            CmdServer.ins.listen(CmdType.MainWinClosed, () =>
            {
                coreThread.Stop();
                monitorThread.Stop();
            });
        }
    }
}
