﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using parkMonitor.DB;
using parkMonitor.LOG;
using parkMonitor.entity;
using parkMonitor.model;
using System.Configuration;
using System.Threading;
using parkMonitor.server.uiLogServer;

namespace parkMonitor.server.CoreThread
{
    class CoreThreadTest2 : IEquipments, ICoreThreadDoWorking
    {

        int equipmentStatus_address;//设备总控状态地址
        //获取PLC句柄
        IEquipments PLC;
        //获取队列句柄
        IEquipments queuingThread;
        //获取号牌句柄
        IEquipments NumMachine;

        string[] equipNames = new string[] { EquipmentName.PLC, EquipmentName.NumMachine, EquipmentName.Web, EquipmentName.Queue };

        public CoreThreadTest2()
        {
            equipmentStatus_address = Convert.ToInt32(ConfigurationManager.AppSettings["equipmentStatus_address"]);
        }

        public void Start()
        {

            for (int i = 0; i < equipNames.Length; ++i)
            {
                IEquipments equip = EquipmentSimpleFactory.ins.CreateEquipment(equipNames[i]);
                if (equip != null)
                {
                    equip.Start();
                }
            }
            PLC = EquipmentSimpleFactory.ins.FindEquipment(EquipmentName.PLC);
            queuingThread = EquipmentSimpleFactory.ins.FindEquipment(EquipmentName.Queue);
            NumMachine = EquipmentSimpleFactory.ins.FindEquipment(EquipmentName.NumMachine);
            //BeginWorking();
            //监听总状态改变消息
            //由监控线程发出
            AsyncCmdServer.ins.listen(AsyncCmdType.TotalStatusChanged, (AlarmStatus type) =>
            {
                if (type != AlarmStatus.Normal)
                {
                    hangUp();
                }
            });
        }

        public AbstractMessage GetMessage()
        {
            return null;
        }

        public void SetMessage(AbstractMessage message)
        {

        }

        public void Stop()
        {
            for (int i = 0; i < equipNames.Length; ++i)
            {
                IEquipments equip = EquipmentSimpleFactory.ins.FindEquipment(equipNames[i]);
                if (equip != null)
                {
                    equip.Stop();
                }
            }
        }

        public void BeginWorking()
        {
            while (true)
            {
                Func<AbstractMessage> func = new Func<AbstractMessage>(GetExecuteNumberPlate);

                TaskFactory taskFactory = new TaskFactory();
                List<Task> tasklist = new List<Task>();
                IAsyncResult result = func.BeginInvoke(null, null);
                Action act1 = new Action(() =>
                {
                    GetTotalStatus();
                });
                tasklist.Add(taskFactory.StartNew(act1));
                Task.WaitAll(tasklist.ToArray());
                Command queueCmd = (Command)func.EndInvoke(result);
                SimpleCMDFactory simpleCMDFactory = new SimpleCMDFactory();               
                AbstractCmd abstractCmd = simpleCMDFactory.createCmd(queueCmd);
                abstractCmd.executeCmd(queueCmd);
                Thread.Sleep(100);
            }
        }

        /// <summary>挂起</summary>
        public void hangUp()
        {

        }

        //获取PLC总控状态
        private void GetTotalStatus()
        {
            PLCMessage PLCMsg = null;
            int normalStatus = 0;
            while (true)
            {
                PLCMsg = (PLCMessage)PLC.GetMessage();
                if (PLCMsg != null && PLCMsg.plcList != null && PLCMsg.plcList.Count != 0)
                {
                    normalStatus = Convert.ToInt32(PLCMsg.plcList[equipmentStatus_address].Value);
                }
                //设备总控状态
                if (normalStatus == 1)
                {
                    UILogServer.ins.log("设备总状态正常");
                    break;
                }
                Thread.Sleep(100);
            }
        }
        //获取可执行号牌
        private AbstractMessage GetExecuteNumberPlate()
        {
            AbstractMessage msg = null;
            while (true)
            {
                msg = queuingThread.GetMessage();
                if (msg != null)
                {
                    break;
                }
            }
            return msg;
        }
    }
}
